<?php
/******************************************************************************/
//                               © lokanaft                                   //
/******************************************************************************/
/**
 * Не пример класса для работы с php шаблонами
 */
class phpLokaTpl{

    private static $tpl_vars   = array();
    private $tpl_folder;
    private $tpl_file;

    public function __construct($tpl_folder, $tpl_file){
        $this->tpl_folder = $tpl_folder;
        $this->tpl_file   = $tpl_file;
    }
////////////////////////////////////////////////////////////////////////////////
    /**
     * Показывает файл шаблона
     * параметр $tpl_file <s>оставлен для совместимости</s>
     * используется, как мною и задумывался
     * У него такое название, чтобы он случайно не перезатёрся другой переменной с таким же названием
     */
    public function display($tpl_file_9845641){

        global $_LANG;
        $tpl_file_9845641 = empty($tpl_file_9845641) ? $this->tpl_file : pathinfo($tpl_file_9845641, PATHINFO_FILENAME);
        extract(self::$tpl_vars[$tpl_file_9845641], EXTR_SKIP);
        //var_dump(self::$tpl_vars);
        unset(self::$tpl_vars[$tpl_file_9845641]);//после вывода содержимое чистится

        include(TEMPLATE_DIR . $this->tpl_folder.'/'.$tpl_file_9845641.'.php');

    }
    /**
     * Добавляет переменную в набор
     * В третьем параметре вся суть - вы можете назначить переменную
     * в ещё несуществующий вызов
     */
    public function assign($tpl_var, $value, $tpl_file = ''){

        $tpl_file = empty($tpl_file) ? pathinfo($this->tpl_file, PATHINFO_FILENAME) : $tpl_file;
        if (is_array($tpl_var)){
            foreach ($tpl_var as $key => $val) {
                if($key && !is_numeric($key)){//очевидно должно быть именно так
                    self::$tpl_vars[$tpl_file][$key] = $val;
                }
            }
        }else{
            if($tpl_var && !is_numeric($tpl_var)){//ну и здесь естесно
                self::$tpl_vars[$tpl_file][$tpl_var] = $value;
            }
        }

        return $this;

    }
    /**
     * Статичная версия с обязательным параметром шаблона для вывода
     */
    public static function assignS($tpl_var, $value, $tpl_file){

        if (is_array($tpl_var)){
            foreach ($tpl_var as $key => $val) {
                if($key && !is_numeric($key)){
                    self::$tpl_vars[$tpl_file][$key] = $val;
                }
            }
        }else{
            if($tpl_var && !is_numeric($tpl_var)){
                self::$tpl_vars[$tpl_file][$tpl_var] = $value;
            }
        }

        return true;

    }

////////////////////////////////////////////////////////////////////////////////


    public static function truncate($string, $length = 80, $etc = '...', $break_words = false, $middle = false){
        if ($length == 0)
            return '';

        if (mb_strlen($string) > $length) {
            $length -= min($length, mb_strlen($etc));
            if (!$break_words && !$middle) {
                $string = preg_replace('/\s+?(\S+)?$/u', '', mb_substr($string, 0, $length+1));
            }
            if(!$middle) {
                return mb_substr($string, 0, $length) . $etc;
            } else {
                return mb_substr($string, 0, $length/2) . $etc . mb_substr($string, -$length/2);
            }
        } else {
            return $string;
        }
    }
    
    public static function rating($rating){
            if ($rating==0) {
                    $html = '<span style="color:gray;">0</span>';
            } elseif ($rating>0){
                    $html = '<span style="color:green">+'.$rating.'</span>';
            } else {
                    $html = '<span style="color:red">'.$rating.'</span>';
            }
            return $html;
    }

    public static function stripTags($string, $replace_with_space = true){
        if ($replace_with_space)
            return preg_replace('!<[^>]*?>!', ' ', $string);
        else
            return strip_tags($string);
    }
    
    public static function cityInput($params){

        global $_LANG;

        array_walk($params, create_function('&$value', 'return htmlspecialchars($value);'));

        if(!isset($params['placeholder'])){ $params['placeholder'] = $_LANG['SELECT_CITY']; }
        if(!isset($params['width'])){ $params['width'] = '100%'; }
        if(!isset($params['input_width'])){ $params['input_width'] = '150px'; }
        if(!isset($params['city_id'])){ $params['city_id'] = 0; }
        if(!isset($params['region_id'])){ $params['region_id'] = 0; }
        if(!isset($params['country_id'])){ $params['country_id'] = 0; }
        if(!isset($params['value'])){ $params['value'] = ''; }

        cmsPage::getInstance()->addHeadJS('components/geo/js/geo.js');

        $id = uniqid();

        $display = $params['value'] ? '' : 'style="display:none"';

        return '<div class="text-input city_block" id="'.$id.'" style="width:'.$params['width'].'">
                    <input type="hidden" value="'.$params['value'].'" name="'.$params['name'].'" class="city_name" />
                    <input type="hidden" value="'.$params['city_id'].'" name="city_id" class="city_id" />
                    <input type="hidden" value="'.$params['region_id'].'" name="region_id" class="region_id" />
                    <input type="hidden" value="'.$params['country_id'].'" name="country_id" class="country_id" />
                    <input readonly="readonly" placeholder="'.$params['placeholder'].'" type="text" value="'.$params['value'].'" class="city_view" onclick="geo.viewForm(\''.$id.'\');return false;" style="width:'.$params['input_width'].'" />
                    <a class="city_link" id="city_clear_link" href="#" onclick="geo.clear(\''.$id.'\');return false;" '.$display.'>'.$_LANG['DELETE'].'</a>
                    <a class="city_link" href="#" onclick="geo.viewForm(\''.$id.'\');return false;">'.$_LANG['SELECT'].'</a>
                </div>' . "\n";

    }
    
    public static function dateform($params){

        if (empty($params['element'])) {
            $params['element'] = 'birthdate';
        }
        if (empty($params['seldate'])) {
            $params['seldate'] = false;
        }

        $year_from = 1950;
        $year_to   = intval(date('Y'));
        $day_default=1; $month_default=1; $year_default=1980;
        global $_LANG;

        $html = '';

        if($params['seldate']){
            $parts = explode('-', $params['seldate']);
            if ($parts[2]){
                $day_default = (int)$parts[2];
            }
            if ($parts[1]){
                $month_default = (string)$parts[1];
            }
            if ($parts[0]){
                $year_default = (int)$parts[0];
            }
        }

        // Дни
        $html .= '<select name="'.$params['element'].'[day]">' . "\n";
        for($day=1; $day<=31;$day++){
            if ($day<10){ $day = '0'.$day; }
            if ($day == $day_default){
                $html .= '<option value="'.$day.'" selected="selected">'.$day.'</option>'. "\n";
            } else {
                $html .= '<option value="'.$day.'">'.$day.'</option>'. "\n";
            }
        }
        $html .= '</select>'. "\n";

        // Месяцы
        $html .= '<select name="'.$params['element'].'[month]">' . "\n";
        for($month=1; $month<13; $month++){
            if ($month<10){ $month = '0'.$month; }
            if (($month) == $month_default){
                $html .= '<option value="'.($month).'" selected="selected">'.$_LANG['MONTH_'.$month.'_ONE'].'</option>'. "\n";
            } else {
                $html .= '<option value="'.($month).'">'.$_LANG['MONTH_'.$month.'_ONE'].'</option>'. "\n";
            }
        }
        $html .= '</select>'. "\n";

        // Года
        $html .= '<select name="'.$params['element'].'[year]">'. "\n";
        for($year=$year_from; $year<=$year_to;$year++){
            if ($year == $year_default){
                $html .= '<option value="'.$year.'" selected="selected">'.$year.'</option>'. "\n";
            } else {
                $html .= '<option value="'.$year.'">'.$year.'</option>'. "\n";
            }
        }
        $html .= '</select>'. "\n";

        return $html;

    }

    public static function comments($params){

        if (!$params['target']) { return false; }
        if (!$params['target_id']) { return false; }

        cmsCore::includeComments();

        comments($params['target'], $params['target_id'], $params['labels']);

        return;

    }
    
    public static function noSpam($email, $filterLevel = 'normal'){
    $email = strrev($email);
    $email = preg_replace('[\.]', '/', $email, 1);
    $email = preg_replace('[@]', '/', $email, 1);

    if($filterLevel == 'low')
    {
        $email = strrev($email);
    }

    return $email;
}

}

?>
